summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorBrian Behlendorf <behlendorf1@llnl.gov>2010-09-10 21:44:17 -0700
committerBrian Behlendorf <behlendorf1@llnl.gov>2010-09-11 20:54:41 -0700
commit2c4834f87af4beec4b16157622c85d2850cce25f (patch)
treefd389b2c63285dd28249b23fe63d054ec884938e
parentac063c48ae12061bbe0f66b3a9d641239782ae62 (diff)
Wait up to timeout seconds for udev devicezfs-0.5.1
Occasional failures were observed in zconfig.sh because udev could be delayed for a few seconds. To handle this the wait_udev function has been added to wait for timeout seconds for an expected device before returning an error. By default callers currently use a 30 seconds timeout which should be much longer than udev ever needs but not so long to worry the test suite is hung.
-rw-r--r--scripts/common.sh.in17
-rwxr-xr-xscripts/zconfig.sh17
-rwxr-xr-xscripts/zfs.sh1
3 files changed, 29 insertions, 6 deletions
diff --git a/scripts/common.sh.in b/scripts/common.sh.in
index 65e897d85..57508be9f 100644
--- a/scripts/common.sh.in
+++ b/scripts/common.sh.in
@@ -441,3 +441,20 @@ run_test() {
skip_one_test ${TEST_NUM} "${TEST_NAME}"
fi
}
+
+wait_udev() {
+ local DEVICE=$1
+ local DELAY=$2
+ local COUNT=0
+
+ while [ ! -e ${DEVICE} ]; do
+ if [ ${COUNT} -gt ${DELAY} ]; then
+ return 1
+ fi
+
+ let COUNT=${COUNT}+1
+ sleep 1
+ done
+
+ return 0
+}
diff --git a/scripts/zconfig.sh b/scripts/zconfig.sh
index f741d4e54..3d965bbca 100755
--- a/scripts/zconfig.sh
+++ b/scripts/zconfig.sh
@@ -148,7 +148,7 @@ zconfig_zvol_device_stat() {
local COUNT=0
# Briefly delay for udev
- sleep 1
+ sleep 3
# Pool exists
stat ${POOL_NAME} &>/dev/null && let COUNT=$COUNT+1
@@ -348,7 +348,8 @@ test_6() {
mount /dev/${FULL_ZVOL_NAME}1 /tmp/${ZVOL_NAME}1 || fail 7
# Snapshot the pristine ext2 filesystem and mount it read-only.
- ${ZFS} snapshot ${FULL_SNAP_NAME} && sleep 1 || fail 8
+ ${ZFS} snapshot ${FULL_SNAP_NAME} || fail 8
+ wait_udev /dev/${FULL_SNAP_NAME}1 30 || fail 8
mkdir -p /tmp/${SNAP_NAME}1 || fail 9
mount /dev/${FULL_SNAP_NAME}1 /tmp/${SNAP_NAME}1 &>/dev/null || fail 10
@@ -407,7 +408,8 @@ test_7() {
mount /dev/${FULL_ZVOL_NAME}1 /tmp/${ZVOL_NAME}1 || fail 7
# Snapshot the pristine ext2 filesystem and mount it read-only.
- ${ZFS} snapshot ${FULL_SNAP_NAME} && sleep 1 || fail 8
+ ${ZFS} snapshot ${FULL_SNAP_NAME} || fail 8
+ wait_udev /dev/${FULL_SNAP_NAME}1 30 || fail 8
mkdir -p /tmp/${SNAP_NAME}1 || fail 9
mount /dev/${FULL_SNAP_NAME}1 /tmp/${SNAP_NAME}1 &>/dev/null || fail 10
@@ -421,7 +423,8 @@ test_7() {
diff -ur ${SRC_DIR} /tmp/${SNAP_NAME}1${SRC_DIR} &>/dev/null && fail 13
# Clone from the original pristine snapshot
- ${ZFS} clone ${FULL_SNAP_NAME} ${FULL_CLONE_NAME} && sleep 1 || fail 14
+ ${ZFS} clone ${FULL_SNAP_NAME} ${FULL_CLONE_NAME} || fail 14
+ wait_udev /dev/${FULL_CLONE_NAME}1 30 || fail 14
mkdir -p /tmp/${CLONE_NAME}1 || fail 15
mount /dev/${FULL_CLONE_NAME}1 /tmp/${CLONE_NAME}1 || fail 16
@@ -491,11 +494,13 @@ test_8() {
sync || fail 9
# Snapshot the ext3 filesystem so it may be sent.
- ${ZFS} snapshot ${FULL_SNAP_NAME1} && sleep 1 || fail 11
+ ${ZFS} snapshot ${FULL_SNAP_NAME1} || fail 11
+ wait_udev /dev/${FULL_SNAP_NAME1} 30 || fail 11
# Send/receive the snapshot from POOL_NAME1 to POOL_NAME2
(${ZFS} send ${FULL_SNAP_NAME1} | \
- ${ZFS} receive ${FULL_ZVOL_NAME2}) && sleep 1 || fail 12
+ ${ZFS} receive ${FULL_ZVOL_NAME2}) || fail 12
+ wait_udev /dev/${FULL_ZVOL_NAME2}1 30 || fail 12
# Mount the sent ext3 filesystem.
mkdir -p /tmp/${FULL_ZVOL_NAME2}1 || fail 13
diff --git a/scripts/zfs.sh b/scripts/zfs.sh
index 523fbfcc0..6060fbaa8 100755
--- a/scripts/zfs.sh
+++ b/scripts/zfs.sh
@@ -69,6 +69,7 @@ if [ ${UNLOAD} ]; then
else
check_modules || die "${ERROR}"
load_modules "$@"
+ wait_udev /dev/zfs 30
fi
exit 0